package core

import "git.urbach.dev/cli/q/src/asm"

// Compile turns a function into machine code.
func (f *Function) Compile() {
	f.AddLabel(asm.Label{
		Name: f.UniqueName,
		Type: asm.FunctionLabel,
	})

	f.Err = f.CompileTokens(f.Body)
	f.Return()

	for _, call := range f.deferred {
		call()
	}
}
