package core

import (
	"git.urbach.dev/cli/q/src/asm"
	"git.urbach.dev/cli/q/src/eval"
)

// ValueToMemory moves a value into a memory region.
func (f *Function) ValueToMemory(value eval.Value, memory asm.Memory) {
	switch value := value.(type) {
	case *eval.Number:
		f.MemoryNumber(asm.STORE, memory, value.Number)
	case *eval.Register:
		f.MemoryRegister(asm.STORE, memory, value.Register)
	case *eval.Memory:
		tmp := f.NewRegister()
		f.MemoryRegister(asm.LOAD, value.Memory, tmp)
		f.MemoryRegister(asm.STORE, memory, tmp)
		f.FreeRegister(tmp)
	case *eval.Label:
		f.MemoryLabel(asm.STORE, memory, value.Label)
	}
}
